module.exports = class DynamicPublicPathPlugin {
	publicPath = '/';
	constructor(path) {
		this.publicPath = path;
	}
	apply(compiler) {
		compiler.hooks.make.tap('MutateRuntime', compilation => {
			compilation.hooks.runtimeModule.tap('MutateRuntime', module => {
				const isPublicPathRuntimeModule =
					module.constructor.name === 'PublicPathRuntimeModule';

				if (!isPublicPathRuntimeModule) {
					return;
				}

				const [key] = module.getGeneratedCode().split('=');

				module._cachedGeneratedCode = `${key} = (function() {
					// change publicPath to currentScript
					return '${this.publicPath}';
				})();`;

				return module;
			});
		});
	}
};
